searchNodes=[{"doc":"Helpers used to manage multitenancy","ref":"AshPostgres.MultiTenancy.html","title":"AshPostgres.MultiTenancy","type":"module"},{"doc":"","ref":"AshPostgres.MultiTenancy.html#create_tenant/2","title":"AshPostgres.MultiTenancy.create_tenant/2","type":"function"},{"doc":"","ref":"AshPostgres.MultiTenancy.html#migrate_tenant/2","title":"AshPostgres.MultiTenancy.migrate_tenant/2","type":"function"},{"doc":"","ref":"AshPostgres.MultiTenancy.html#rename_tenant/3","title":"AshPostgres.MultiTenancy.rename_tenant/3","type":"function"},{"doc":"Generates migrations, and stores a snapshot of your resources.Options:apis - a comma separated list of API modules, for which migrations will be generatedsnapshot_path - a custom path to store the snapshots, defaults to &quot;priv/resource_snapshots&quot;migration_path - a custom path to store the migrations, defaults to &quot;priv&quot;. Migrations are stored in a folder for each repo, so priv/repo_name/migrationstenant_migration_path - Same as migration_path, except for any tenant specific migrationsdrop_columns - whether or not to drop columns as attributes are removed. See below for moreFlags:quiet - messages for file creations will not be printedno_format - files that are created will not be formatted with the code formatterdry_run - no files are created, instead the new migration is printedcheck_migrated - no files are created, returns an exit(1) code if the current snapshots and resources don't fitSnapshotsSnapshots are stored in a folder for each table that migrations are generated for. Each snapshot is stored in a file with a timestamp of when it was generated. This is important because it allows for simultaneous work to be done on separate branches, and for rolling back changes more easily, e.g removing a generated migration, and deleting the most recent snapshot, without having to redo all of itDropping columnsGenerally speaking, it is bad practice to drop columns when you deploy a change that would remove an attribute. The main reasons for this are backwards compatibility and rolling restarts. If you deploy an attribute removal, and run migrations. Regardless of your deployment sstrategy, you won't be able to roll back, because the data has been deleted. In a rolling restart situation, some of the machines/pods/whatever may still be running after the column has been deleted, causing errors. With this in mind, its best not to delete those columns until later, after the data has been confirmed unnecessary. To that end, the migration generator leaves the column dropping code commented. You can pass --drop_columns to tell it to uncomment those statements. Additionally, you can just uncomment that code on a case by case basis.Conflicts/Multiple ResourcesThe migration generator can support multiple schemas using the same table. It will raise on conflicts that it can't resolve, like the same field with different types. It will prompt to resolve conflicts that can be resolved with human input. For example, if you remove an attribute and add an attribute, it will ask you if you are renaming the column in question. If not, it will remove one column and add the other.Additionally, it lowers things to the database where possible:DefaultsThere are three anonymous functions that will translate to database-specific defaults currently:&amp;Ash.uuid/0 - Only if uuid-ossp is in your c:AshPostgres.Repo.installed_extensions()&amp;Ecto.UUID.generate/0 - Only if uuid-ossp is in your c:AshPostgres.Repo.installed_extensions()&amp;DateTime.utc_now/0Non-function default values will be dumped to their native type and inspected. This may not work for some types, and may require manual intervention/patches to the migration generator code.IdentitiesIdentities will cause the migration generator to generate unique constraints. If multiple resources target the same table, you will be asked to select the primary key, and any others will be added as unique constraints.","ref":"Mix.Tasks.AshPostgres.GenerateMigrations.html","title":"Mix.Tasks.AshPostgres.GenerateMigrations","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.AshPostgres.GenerateMigrations.html#run/1","title":"Mix.Tasks.AshPostgres.GenerateMigrations.run/1","type":"function"},{"doc":"A postgres extension library for Ash.AshPostgres.DataLayer provides a DataLayer, and a DSL extension to configure that data layer.The dsl extension exposes the postgres section. See: AshPostgres.DataLayer for more.","ref":"AshPostgres.html","title":"AshPostgres","type":"module"},{"doc":"A stringified version of the base_filter, to be used in a where clause when generating unique indexes","ref":"AshPostgres.html#base_filter_sql/1","title":"AshPostgres.base_filter_sql/1","type":"function"},{"doc":"Whether or not to create a tenant for a given resource","ref":"AshPostgres.html#manage_tenant_create?/1","title":"AshPostgres.manage_tenant_create?/1","type":"function"},{"doc":"The template for a managed tenant","ref":"AshPostgres.html#manage_tenant_template/1","title":"AshPostgres.manage_tenant_template/1","type":"function"},{"doc":"Whether or not to update a tenant for a given resource","ref":"AshPostgres.html#manage_tenant_update?/1","title":"AshPostgres.manage_tenant_update?/1","type":"function"},{"doc":"Whether or not the resource should be included when generating migrations","ref":"AshPostgres.html#migrate?/1","title":"AshPostgres.migrate?/1","type":"function"},{"doc":"The configured repo for a resource","ref":"AshPostgres.html#repo/1","title":"AshPostgres.repo/1","type":"function"},{"doc":"Skip generating unique indexes when generating migrations","ref":"AshPostgres.html#skip_unique_indexes?/1","title":"AshPostgres.skip_unique_indexes?/1","type":"function"},{"doc":"The configured table for a resource","ref":"AshPostgres.html#table/1","title":"AshPostgres.table/1","type":"function"},{"doc":"A postgres data layer that levereges Ecto's postgres capabilities.Table of Contentspostgresmanage_tenantpostgresPostgres data layer configurationmanage_tenantExamples:postgres do repo MyApp.Repo table &quot;organizations&quot; end :repo - Required. The repo that will be used to fetch your data. See the AshPostgres.Repo documentation for more:migrate? - Whether or not to include this resource in the generated migrations with mix ash.generate_migrations The default value is true.:base_filter_sql - A raw sql version of the base_filter, e.g representative = true. Required if trying to create a unique constraint on a resource with a base_filter:skip_unique_indexes - Skip generating unique indexes when generating migrations The default value is false.:table - Required. The table to store and read the resource frommanage_tenantConfiguration for the behavior of a resource that manages a tenantExamples:manage_tenant do template [&quot;organization_&quot;, :id] create? true update? false end :template - Required. A template that will cause the resource to create/manage the specified schema. Use this if you have a resource that, when created, it should create a new tenant for you. For example, if you have a customer resource, and you want to create a schema for each customer based on their id, e.g customer_10 set this option to [&quot;customer_&quot;, :id]. Then, when this is created, it will create a schema called [&quot;customer_&quot;, :id], and run your tenant migrations on it. Then, if you were to change that customer's id to 20, it would rename the schema to customer_20. Generally speaking you should avoid changing the tenant id.:create? - Whether or not to automatically create a tenant when a record is created The default value is true.:update? - Whether or not to automatically update the tenant name if the record is udpated The default value is true.","ref":"AshPostgres.DataLayer.html","title":"AshPostgres.DataLayer","type":"module"},{"doc":"A filter predicate that filters based on trigram similarity.See the postgres docs on https://www.postgresql.org/docs/9.6/pgtrgm.html for more information.Requires the pg_trgm extension. Configure which extensions you have installed in your AshPostgres.RepoAt least one of the equals, greater_than and less_than# Example filter(query, [trigram_similarity: [:name, &quot;geoff&quot;, [greater_than: 0.4]]])","ref":"AshPostgres.Functions.TrigramSimilarity.html","title":"AshPostgres.Functions.TrigramSimilarity","type":"module"},{"doc":"","ref":"AshPostgres.Functions.TrigramSimilarity.html#args/0","title":"AshPostgres.Functions.TrigramSimilarity.args/0","type":"function"},{"doc":"Callback implementation for Ash.Filter.Predicate.compare/2.","ref":"AshPostgres.Functions.TrigramSimilarity.html#compare/2","title":"AshPostgres.Functions.TrigramSimilarity.compare/2","type":"function"},{"doc":"","ref":"AshPostgres.Functions.TrigramSimilarity.html#name/0","title":"AshPostgres.Functions.TrigramSimilarity.name/0","type":"function"},{"doc":"","ref":"AshPostgres.Functions.TrigramSimilarity.html#new/1","title":"AshPostgres.Functions.TrigramSimilarity.new/1","type":"function"},{"doc":"Resources that use the AshPostgres data layer use a Repo to access the database.This repo is a slightly modified version of an Ecto.Repo.You can use Ecto.Repo's init/2 to configure your repo like normal, but instead of returning {:ok, config}, use super(config) to pass the configuration to the AshPostgres.Repo implementation.Installed ExtensionsTo configure your list of installed extensions, define installed_extensions/0Extensions that are relevant to ash_postgres:&quot;uuid-ossp&quot; - Sets UUID primary keys defaults in the migration generator&quot;pg_trgm&quot; - Makes the AshPostgres.Predicates.Trigram custom predicate availabledef installed_extensions() do [&quot;pg_trgm&quot;, &quot;uuid-ossp&quot;] end","ref":"AshPostgres.Repo.html","title":"AshPostgres.Repo","type":"behaviour"},{"doc":"Return a list of all schema names (only relevant for a multitenant implementation)","ref":"AshPostgres.Repo.html#c:all_tenants/0","title":"AshPostgres.Repo.all_tenants/0","type":"callback"},{"doc":"Use this to inform the data layer about what extensions are installed","ref":"AshPostgres.Repo.html#c:installed_extensions/0","title":"AshPostgres.Repo.installed_extensions/0","type":"callback"},{"doc":"The path where your tenant migrations are stored (only relevant for a multitenant implementation)","ref":"AshPostgres.Repo.html#c:tenant_migrations_path/0","title":"AshPostgres.Repo.tenant_migrations_path/0","type":"callback"},{"doc":"Generates migrations based on resource snapshotsSee Mix.Tasks.AshPostgres.GenerateMigrations for more information.","ref":"AshPostgres.MigrationGenerator.html","title":"AshPostgres.MigrationGenerator","type":"module"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#changing_multitenancy_affects_identities?/2","title":"AshPostgres.MigrationGenerator.changing_multitenancy_affects_identities?/2","type":"function"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#generate/2","title":"AshPostgres.MigrationGenerator.generate/2","type":"function"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#get_existing_snapshot/2","title":"AshPostgres.MigrationGenerator.get_existing_snapshot/2","type":"function"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#get_snapshot/1","title":"AshPostgres.MigrationGenerator.get_snapshot/1","type":"function"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#has_reference?/2","title":"AshPostgres.MigrationGenerator.has_reference?/2","type":"function"},{"doc":"Verifies that the repo is configured correctly","ref":"AshPostgres.Transformers.VerifyRepo.html","title":"AshPostgres.Transformers.VerifyRepo","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"AshPostgres.Transformers.VerifyRepo.html#after?/1","title":"AshPostgres.Transformers.VerifyRepo.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"AshPostgres.Transformers.VerifyRepo.html#before?/1","title":"AshPostgres.Transformers.VerifyRepo.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"AshPostgres.Transformers.VerifyRepo.html#transform/2","title":"AshPostgres.Transformers.VerifyRepo.transform/2","type":"function"},{"doc":"AshPostgres AshPostgres supports all capabilities of an Ash data layer, and it will most likely stay that way, as postgres is the primary target/most maintained data layer.Custom Predicates:AshPostgres.Predicates.Trigram","ref":"readme.html","title":"AshPostgres","type":"extras"},{"doc":"See the DSL documentation in AshPostgres.DataLayer for DSL documentation","ref":"readme.html#dsl","title":"AshPostgres - DSL","type":"extras"},{"doc":"First, ensure you've added ash_postgres to your mix.exs file.{:ash_postgres, &quot;~&gt; x.y.z&quot;}To use this data layer, you need to define an Ecto.Repo. AshPostgres adds some functionality on top of ecto repos, so you'll want to use AshPostgres.RepoThen, configure your resource like so:postgres do repo MyApp.Repo table &quot;table_name&quot; end","ref":"readme.html#usage","title":"AshPostgres - Usage","type":"extras"},{"doc":"See the documentation for Mix.Tasks.AshPostgres.GenerateMigrations for how to generate migrations from your resources","ref":"readme.html#generating-migrations","title":"AshPostgres - Generating Migrations","type":"extras"},{"doc":"MultitenancyMultitenancy in AshPostgres is implemented via postgres schemas. For more information on schemas, see postgres' schema documentationImplementing multitenancy via schema's involves tracking &quot;tenant migrations&quot; separately from migrations for your public schema. You can see what this looks like by simply creating a multitenant resource, and using the migration generator mix ash_postgres.generate_migrations --apis My.Api. It will put schema specific migrations in priv/repo/tenant_migrations. When you generate migrations, you'll want to be sure to audit migrations in both directories. Additionally, when you deploy, you'll want to run your migrations, as well as running them with the migrations path priv/repo/tenant_migrations.","ref":"multitenancy.html","title":"Multitenancy","type":"extras"},{"doc":"The generated migrations include a lot of niceties around multitenancy. Specifically, foreign keys will point at tables in the correct schema, and foreign keys to non-multitenant resources will point to the correct table. If you are using attribute multitenancy, foreign keys to tables also using attribute multitenancy will be composite foreign keys, including the tenant attribute as well as the referencing field.Migrations in the tenant directory will call repo().all_tenants(), which is a callback you will need to implement in your repo that should return a list of all schemas that need to be migrated.","ref":"multitenancy.html#generated-migrations","title":"Multitenancy - Generated migrations","type":"extras"},{"doc":"By setting the template configuration, in the manage_tenant section, you can cause the creation/updating of a given resource to create/rename tenants. For example:defmodule MyApp.Organization do use Ash.Resource, ... postgres do ... manage_tenant do template [&quot;org_&quot;, :id] end end endWith this configuration, if you create an organization, it will create a corresponding schema, e.g. org_10 in the database. Then it will run your tenant migrations on that schema. To override the tenant_migrations path, implement the AshPostgres.Repo.tenant_migrations_path/0 callback.Notice that manage_tenant is nested inside the postgres block. This is because the method of managing tenants is specific to postgres, and if another data layer supported multitenancy they may or may not support managing tenants in the same way.","ref":"multitenancy.html#automatically-managing-tenants","title":"Multitenancy - Automatically managing tenants","type":"extras"}]